using Indotalent.Infrastructure.Database;
using MediatR;
using Microsoft.EntityFrameworkCore;

namespace Indotalent.Features.Inventory.UnitMeasure.Cqrs;

public class GetUnitMeasureListResponse
{
    public string? Id { get; set; }
    public string? Name { get; set; }
    public string? Description { get; set; }
    public DateTimeOffset? CreatedAt { get; set; }
    public string? CreatedBy { get; set; }
    public DateTimeOffset? UpdatedAt { get; set; }
    public string? UpdatedBy { get; set; }
}

public record GetUnitMeasureListQuery() : IRequest<List<GetUnitMeasureListResponse>>;

public class GetUnitMeasureListHandler : IRequestHandler<GetUnitMeasureListQuery, List<GetUnitMeasureListResponse>>
{
    private readonly AppDbContext _context;

    public GetUnitMeasureListHandler(AppDbContext context) => _context = context;

    public async Task<List<GetUnitMeasureListResponse>> Handle(GetUnitMeasureListQuery request, CancellationToken cancellationToken)
    {
        return await _context.UnitMeasure
            .AsNoTracking()
            .OrderBy(x => x.Name)
            .Select(x => new GetUnitMeasureListResponse
            {
                Id = x.Id,
                Name = x.Name,
                Description = x.Description,
                CreatedAt = x.CreatedAt,
                CreatedBy = x.CreatedBy,
                UpdatedAt = x.UpdatedAt,
                UpdatedBy = x.UpdatedBy,
            })
            .ToListAsync(cancellationToken);
    }
}